class Fdcart
  require 'models/cart'
  def initialize(owner)
    @owner = owner
  end
  def add(part, count, *extra)
    cart = nil
    count.to_i.times do
      cart = {
          part: part,
          owner: @owner
      }
      extra.each do |val|
        if val
          if !val[:externo].blank?
            cart[:proveedor_externo] = val[:externo]
          elsif val.is_a?(Almacen)
            cart[:part_owner] = val
          elsif val.is_a?(PluginVentaPrecio)
            cart[:transporte] = val
          elsif val.is_a?(OrdenReparacion)
            cart[:belongs] = val
          elsif val.is_a?(User)
            cart[:user] = val
          end
        end
      end
      cart = Cart.create!(cart)
    end
    cart || nil
  end

  def remove(id)
    Cart.find(id)&.destroy
  end

  def get
    Cart.where(owner: @owner)
  end

  def get_by_ids(ids: [])
    get.where(:_id.in => ids)
  end
  def get_by_belongs_ids(ids: [])
    Cart.where(
        :belongs_id.in => ids
    )
  end
  private
end
